﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
'Ported from http://blog.jaimon.co.uk/simpleimageinfo/SimpleImageInfo.java.html
Sub Class_Globals
	Private fx As JFX
	Private gHeight As Int
	Private gWidth As Int
	Private gMimeType As String
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
End Sub

Public Sub FromFile(Dir As String,FileName As String)
	Dim IStream As InputStream = File.OpenInput(Dir,FileName)
	ProcessStream(IStream)
	IStream.Close
End Sub

Public Sub FromInputStream(IStream As InputStream)
	ProcessStream(IStream)
End Sub

Private Sub ProcessStream(IStream As InputStream)
	Dim c1 As Int = Read(IStream)
	Dim c2 As Int = Read(IStream)
	Dim c3 As Int = Read(IStream)
	
	gMimeType = ""
	gWidth = -1
	gHeight = -1
	
	If c1 = 71 And c2 = 73 And c3 = 70 Then								'GIF
		Skip(IStream,3)
		gWidth = ReadVar(IStream,2,False)
		gHeight = ReadVar(IStream,2,False)
		gMimeType = "image/gif"
	Else If c1 == 0xFF And c2 == 0xD8 Then								'JPG
		Dim Marker As Int
		Dim Len As Int
		Do While c3 = 255
			Marker = Read(IStream)
			Len = ReadVar(IStream,2,True)
			If Marker = 192 Or Marker = 192 Or Marker = 194 Then
				Skip(IStream,1)
				gHeight = ReadVar(IStream,2,True)
				gWidth = ReadVar(IStream,2,True)
				gMimeType = "image/jpg"
				Exit
			End If
			Skip(IStream,Len -2)
			c3 = Read(IStream)
		Loop
	else if c1 = 137 And c2 = 80 And c3 = 78  Then 						'PNG
		Skip(IStream,15)
		gWidth = ReadVar(IStream,2,True)
		Skip(IStream,2)
		gHeight = ReadVar(IStream,2,True)
		gMimeType = "image/png"
	else if c1 == 66 And c2 == 77 Then 									'BMP
		Skip(IStream,15)
		gWidth = ReadVar(IStream,2,False)
		Skip(IStream,2)
		gHeight = ReadVar(IStream,2,False)
		gMimeType = "image/bmp"
	Else
		Dim C4 As Int = Read(IStream)
		If (c1 = 77 And c2 = 77 And c3 = 0 And C4 = 42) Or (c1 = 73 And c2 = 73 And c3 = 42 And C4 = 0) Then  'TIFF
			Dim BigEndian As Boolean = c1 = 77
			Dim ifd As Int = 0
			Dim entries As Int
			ifd = ReadVar(IStream,4,BigEndian)
			Skip(IStream, ifd - 8)
			entries = ReadVar(IStream,2,BigEndian)
			Dim Tag As Int
			Dim FieldType As Int
			Dim i As Int
			Dim Count As Long											'ignore
			Dim ValOffset As Int
			For i = 1 To entries - 1
				Tag = ReadVar(IStream,2,BigEndian)
				FieldType = ReadVar(IStream,2,BigEndian)
				Count = ReadVar(IStream,4,BigEndian)
				If FieldType = 3 Or FieldType = 8 Then
					ValOffset = ReadVar(IStream,2,BigEndian)
					Skip(IStream,2)
				Else
					ValOffset = ReadVar(IStream,4,BigEndian)
				End If
				If (Tag == 256) Then
					gWidth = ValOffset
				else if (Tag == 257) Then
					gHeight = ValOffset
				End If
				If gWidth <> -1 And gHeight <> -1 Then
					gMimeType = "image/tiff"
					Exit
				End If
			Next
		End If
	End If
	If gMimeType = "" Then
		Log("################")
		Log("#")
		Log("SimpleImageInfo : Unsupported Image Type")
		Log("#")
		Log("################")
	End If
End Sub

Private Sub Read(IStream As JavaObject) As Int
	Return IStream.RunMethod("read",Null)
End Sub

Private Sub Skip(IStream As JavaObject,Count As Long)
	IStream.RunMethod("skip",Array(Count))
End Sub

Private Sub ReadVar(IStream As InputStream, NoOfBytes As Int, BigEndian As Boolean) As Int
	Dim Ret As Int = 0
	Dim SV As Int
	Dim Cnt As Int
	If BigEndian Then
		SV = (NoOfBytes - 1) * 8
		Cnt = -8
	Else
		SV = 0
		Cnt = 8
	End If
	
	Dim i As Int
	For i = 0 To NoOfBytes -1
		Ret = Bit.Or(Ret,Bit.ShiftLeft(Read(IStream),SV))
		SV = SV + Cnt
	Next
	Return Ret
	
End Sub


Public Sub getHeight As Int
	Return gHeight
End Sub

Public Sub getWidth As Int
	Return gWidth
End Sub

Public Sub getMimeType As String
	Return gMimeType
End Sub

Public Sub ToString As String
	Return $"MIME type : ${gMimeType} ${TAB} Width : ${gWidth} ${TAB} Height : ${gHeight}"$
End Sub
